import { BlockContent, Code, DefinitionContent, Image } from "mdast";
import { MdxJsxFlowElement } from "mdast-util-mdx-jsx";
export type JSXChild = BlockContent | DefinitionContent;
export type HikeTree = {
    depth: 0;
    sections: RemarkSection[];
    parent?: null;
    children: JSXChild[];
    code: Code[];
    images: {
        key: string;
        value: Image;
    }[];
};
export type RemarkSection = {
    depth: number;
    name: string;
    query: string;
    sections: RemarkSection[];
    parent: RemarkSection | HikeTree;
    children: JSXChild[];
    code: Code[];
    images: {
        key: string;
        value: Image;
    }[];
};
export declare function listToTree(hikeElement: MdxJsxFlowElement, prefix?: string): HikeTree;
export declare function isHikeHeading(child: any, prefix: string): any;
//# sourceMappingURL=1.remark-list-to-tree.d.ts.map