import { Code, Image } from "mdast";
import { HikeTree, JSXChild } from "./1.remark-list-to-tree.js";
export type HydratedSection = {
    path: string[];
    query: string;
    name: string;
    sections: HydratedSection[];
    children: JSXChild[];
    code: CodeBlock[];
    images: {
        key: string;
        value: Image;
    }[];
};
export type CodeBlock = {
    value: string;
    lang?: string | null | undefined;
    meta?: string | null | undefined;
    parentPath?: string;
};
export declare function hydrateTree(tree: HikeTree, mdxPath?: string): {
    path: string[];
    query: string;
    name: string;
    sections: HydratedSection[];
    children: JSXChild[];
    code: {
        value: string;
        lang: string | null | undefined;
        meta: string | null | undefined;
        parentPath: string | undefined;
    }[];
    images: {
        key: string;
        value: Image;
    }[];
};
export declare function parseCode(code: Code, mdxPath?: string): {
    value: string;
    lang: string | null | undefined;
    meta: string | null | undefined;
    parentPath: string | undefined;
};
//# sourceMappingURL=2.hydrate-tree.d.ts.map