export function hydrateTree(tree, mdxPath) {
    const { sections, children, code, images } = tree;
    const path = [];
    return {
        path,
        query: "",
        name: "",
        sections: sections.map((section) => hydrateSection(section, path, mdxPath)),
        children: children,
        code: code.map((code) => parseCode(code, mdxPath)),
        images,
    };
}
function hydrateSection(section, parentPath, mdxPath) {
    const { name, query, sections, children, code, images } = section;
    const path = [...parentPath, name];
    return {
        path,
        name,
        query,
        sections: sections.map((section) => hydrateSection(section, path, mdxPath)),
        children: children,
        code: code.map((code) => parseCode(code, mdxPath)),
        images,
    };
}
export function parseCode(code, mdxPath) {
    return {
        value: code.value || "",
        lang: code.lang,
        meta: code.meta,
        parentPath: mdxPath,
    };
}
