import { SKIP, visit } from "estree-util-visit";
export function addBlocksExport(program) {
    // remove default funcion
    // node.body = node.body.filter(
    //   (node: any) => node?.type !== "ExportDefaultDeclaration",
    // )
    var _a, _b, _c;
    // find _createMdxContent
    const { body } = program;
    const _createMdxContent = body.find(({ type, id }) => type === "FunctionDeclaration" && (id === null || id === void 0 ? void 0 : id.name) === "_createMdxContent");
    const [_createMdxContentReturn] = find(_createMdxContent, (node) => node.type === "ReturnStatement");
    // stop if _createMdxContent is returning an element
    // with the hike attribute
    if (!_createMdxContentReturn ||
        ((_a = _createMdxContentReturn.argument) === null || _a === void 0 ? void 0 : _a.type) !== "JSXElement" ||
        !((_c = (_b = _createMdxContentReturn.argument) === null || _b === void 0 ? void 0 : _b.openingElement) === null || _c === void 0 ? void 0 : _c.attributes.find((attr) => { var _a; return ((_a = attr === null || attr === void 0 ? void 0 : attr.name) === null || _a === void 0 ? void 0 : _a.name) === "hike"; }))) {
        return;
    }
    // creatae getBlocks function
    const getBlocks = {
        type: "ExportNamedDeclaration",
        declaration: {
            ...JSON.parse(JSON.stringify(_createMdxContent)),
            id: { type: "Identifier", name: "getBlocks" },
        },
        specifiers: [],
        source: null,
    };
    // insert before _createMdxContent
    body.splice(body.indexOf(_createMdxContent), 0, getBlocks);
    // change getBlocks return to hike object
    const [returnStatement] = find(getBlocks, (node) => node.type === "ReturnStatement");
    const [hikeAttribute] = find(returnStatement, (node) => { var _a; return node.type === "JSXAttribute" && ((_a = node === null || node === void 0 ? void 0 : node.name) === null || _a === void 0 ? void 0 : _a.name) === "hike"; });
    const hikeObject = hikeAttribute.value.expression;
    returnStatement.argument = hikeObject;
    // change _createMdxContent attribute to getBlocks()
    const [_createMdxHikeAttribute] = find(_createMdxContentReturn, (node) => { var _a; return node.type === "JSXAttribute" && ((_a = node === null || node === void 0 ? void 0 : node.name) === null || _a === void 0 ? void 0 : _a.name) === "hike"; });
    _createMdxHikeAttribute.value.expression = {
        type: "CallExpression",
        callee: { type: "Identifier", name: "getBlocks" },
        arguments: [{ type: "Identifier", name: "props" }],
        optional: false,
    };
    // remove `if (!Hike) _missingMdxReference("Hike", true)`
    const [missingMdxReference, parent] = find(getBlocks, (node) => {
        var _a, _b, _c, _d;
        return node.type === "IfStatement" &&
            ((_a = node.test) === null || _a === void 0 ? void 0 : _a.type) === "UnaryExpression" &&
            ((_b = node.test) === null || _b === void 0 ? void 0 : _b.operator) === "!" &&
            ((_d = (_c = node.test) === null || _c === void 0 ? void 0 : _c.argument) === null || _d === void 0 ? void 0 : _d.name) === "Hike";
    });
    if (missingMdxReference) {
        parent.body = parent.body.filter((node) => node !== missingMdxReference);
    }
    // add default props: getBlocks(props = {})
    getBlocks.declaration.params = [
        {
            type: "AssignmentPattern",
            left: { type: "Identifier", name: "props" },
            right: { type: "ObjectExpression", properties: [] },
        },
    ];
    // add if statement
    const ifStatement = {
        type: "IfStatement",
        // test if props._returnBlocks is truthy
        test: {
            type: "MemberExpression",
            object: { type: "Identifier", name: "props" },
            property: { type: "Identifier", name: "_returnBlocks" },
        },
        consequent: {
            type: "BlockStatement",
            body: [
                {
                    type: "ReturnStatement",
                    // return getBlocks(props)
                    argument: {
                        type: "CallExpression",
                        callee: {
                            type: "Identifier",
                            name: "getBlocks",
                        },
                        arguments: [
                            {
                                type: "Identifier",
                                name: "props",
                            },
                        ],
                    },
                },
            ],
        },
    };
    // add if before return
    _createMdxContent.body.body.splice(_createMdxContent.body.body.indexOf(_createMdxContentReturn), 0, ifStatement);
}
function find(node, predicate) {
    let result = [];
    visit(node, (node, key, index, ancestors) => {
        if (predicate(node)) {
            result = [node, ...ancestors.slice().reverse()];
            return SKIP;
        }
    });
    return result;
}
