/// <reference types="react" />
import { MDXProps } from "mdx/types.js";
import { ZodTypeDef, z } from "zod";
type MDXContent = (props: MDXProps) => JSX.Element;
export declare function getBlocks(Content: MDXContent, props?: MDXProps): unknown;
export declare function parseRoot<Output, Def extends ZodTypeDef, Input>(Content: MDXContent, Schema: z.ZodType<Output, Def, Input>, props?: MDXProps): Output;
export declare const Block: z.ZodObject<{
    title: z.ZodString;
    children: z.ZodType<import("react").ReactNode, ZodTypeDef, import("react").ReactNode>;
}, "strip", z.ZodTypeAny, {
    title: string;
    children?: import("react").ReactNode;
}, {
    title: string;
    children?: import("react").ReactNode;
}>;
export declare const CodeBlock: z.ZodObject<{
    meta: z.ZodString;
    value: z.ZodString;
    lang: z.ZodString;
}, "strip", z.ZodTypeAny, {
    meta: string;
    value: string;
    lang: string;
}, {
    meta: string;
    value: string;
    lang: string;
}>;
export declare const ImageBlock: z.ZodObject<{
    url: z.ZodString;
    alt: z.ZodString;
    title: z.ZodString;
}, "strip", z.ZodTypeAny, {
    title: string;
    url: string;
    alt: string;
}, {
    title: string;
    url: string;
    alt: string;
}>;
export declare function parseProps<Output, Def extends ZodTypeDef, Input>(content: unknown, Schema: z.ZodType<Output, Def, Input>): Output;
export {};
//# sourceMappingURL=blocks.d.ts.map