/// <reference types="react" />
type Color = string;
export type Token = [string, Color?, React.CSSProperties?];
export type Whitespace = string;
export type Tokens = (Token | Whitespace)[];
export type InternalToken = {
    value: string;
    style?: React.CSSProperties;
    range: [number, number];
};
export type BlockAnnotation = [
    Capitalize<string>,
    [
        number,
        number
    ],
    string?
];
export type InlineAnnotation = [
    Capitalize<string>,
    number,
    [
        number,
        number
    ],
    string?
];
export type Annotation = BlockAnnotation | InlineAnnotation;
export declare function isBlockAnnotation(annotation: Annotation): annotation is BlockAnnotation;
export declare function isInlineAnnotation(annotation: Annotation): annotation is InlineAnnotation;
export {};
//# sourceMappingURL=common.d.ts.map