import { jsx as _jsx } from "react/jsx-runtime";
import React from "react";
import { DebugHike } from "./debug-hike.js";
export function Hike({ as, hike, ...rest }) {
    if (!as || rest.debug) {
        return _jsx(DebugHike, { hike: hike });
    }
    return React.createElement(as, { hike, ...rest });
}
export function getStepsFromChildren(kids, query = "") {
    const [children, ...slotElements] = React.Children.toArray(kids);
    const slots = {};
    const code = [];
    slotElements.forEach((slotElement) => {
        const { name, query } = slotElement.props || {};
        if (name === "code") {
            code.push(getCodeBlockFromChildren(slotElement.props.children));
        }
        else {
            slots[name] = slots[name] || [];
            slots[name].push(getStepsFromChildren(slotElement.props.children, query));
        }
    });
    return {
        query,
        children: React.Children.toArray(children.props.children).map((e) => e.type === "placeholder" ? _jsx(React.Fragment, {}, e.props.name) : e),
        ...slots,
        code,
    };
}
function getCodeBlockFromChildren(children) {
    const { props } = React.Children.toArray(children)[0];
    return {
        value: props.code,
        meta: props.meta,
        lang: props.lang,
    };
}
