import { visit } from "unist-util-visit";
import { getObjectAttribute } from "./estree.js";
import { parseCode } from "./1.1.remark-list-to-section.js";
export async function transformAllCode(tree, config) {
    var _a;
    if (!((_a = config.components) === null || _a === void 0 ? void 0 : _a.code)) {
        return tree;
    }
    const nodes = [];
    visit(tree, "code", (node) => {
        if ((config === null || config === void 0 ? void 0 : config.ignoreCode) && config.ignoreCode(node)) {
            // ignoring this codeblock
            return;
        }
        nodes.push(node);
    });
    await Promise.all(nodes.map(async (code) => {
        var _a;
        Object.assign(code, {
            type: "mdxJsxFlowElement",
            name: ((_a = config === null || config === void 0 ? void 0 : config.components) === null || _a === void 0 ? void 0 : _a.code) || "Code",
            attributes: [
                {
                    type: "mdxJsxAttribute",
                    name: "codeblock",
                    value: getObjectAttribute(await parseCode(code, config)),
                },
            ],
            children: [],
        });
        delete code.value;
        delete code.lang;
        delete code.meta;
    }));
    return tree;
}
