"use client";
import { jsx as _jsx } from "react/jsx-runtime";
import React from "react";
const StepsContext = React.createContext({
    selectedIndex: 0,
    selectIndex: () => { },
});
export function Steps({ children, ...rest }) {
    const [selectedIndex, selectIndex] = React.useState(0);
    return (_jsx("div", { "data-selected-index": selectedIndex, ...rest, children: _jsx(StepsContext.Provider, { value: {
                selectedIndex,
                selectIndex,
            }, children: children }) }));
}
export function Step({ index, selectOn = ["click"], ...rest }) {
    const { selectedIndex, selectIndex } = React.useContext(StepsContext);
    const eventHandlers = React.useMemo(() => {
        const handlers = {};
        if (selectOn.includes("click")) {
            handlers.onClick = () => selectIndex(index);
        }
        if (selectOn.includes("hover")) {
            handlers.onMouseEnter = () => selectIndex(index);
        }
        return handlers;
    }, [index, selectIndex, selectOn]);
    return (_jsx("div", { "data-selected": selectedIndex === index, ...eventHandlers, ...rest }));
}
export function Display({ values }) {
    const { selectedIndex } = React.useContext(StepsContext);
    return values[selectedIndex];
}
export function useStepIndex() {
    return React.useContext(StepsContext);
}
